#!/bin/env -S deno run --allow-env=PATH_TRANSLATED,REQUEST_METHOD --allow-write=../brochures/

import * as path from "jsr:@std/path";

async function fail(status){
    for await(let byte of Deno.stdin.readable){
        
    }
    console.log("Status: "+status)
    console.log("Content-Type: text/plain")
    console.log()
}

let targetPath = Deno.env.get("PATH_TRANSLATED")

if(!targetPath){
    await fail(400)
    Deno.exit(0)
}

if(Deno.env.get("REQUEST_METHOD") != "PUT"){
    await fail(400)
    Deno.exit(0)
}

await Deno.mkdir(path.dirname(targetPath), {
    recursive: true,
    mode: 0o770
})

let targetFile = null;

try {
    targetFile = await Deno.open(targetPath, {
        write: true,
        createNew: true,
        mode: 0o660
    })
} catch(e) {
    if(e.name == "AlreadyExists"){
        await fail(409)
        Deno.exit(0)
    } else {
        console.error(e)
        throw e
    }
}


if(targetFile){
    await Deno.stdin.readable.pipeTo(targetFile.writable)

    console.log("Status: 201")
    console.log("Content-Type: text/plain")
    console.log()
    console.log("Created")
}