import * as db from "/data.js"

let form = document.getElementById("upload-form")
let submitButton = document.getElementById("submit-button")
let errorContainer = document.getElementById("error-container")
let errorEl = document.getElementById("error")

form.addEventListener("submit", async e => {
    e.preventDefault()
    submitButton.disabled = true
    errorContainer.hidden = true
    let data = new FormData(e.target);
    
    try {

        if(!data.get("title")){
            throw new Error("Veuillez donner le titre de la brochure")
        }

        if(!data.get("file")){
            throw new Error("Aucun fichier selectionne")
        }

        document.location = await db.uploadDocument(data.get("file"), data)

    } catch(e){
        errorEl.textContent = `Erreur : ${e.message}`
        errorContainer.hidden = false
        console.error(e)
    }

    submitButton.disabled = false
})

// API

window.enableField = (selector) => function enableFieldHandler(e){
    let el = document.querySelector(selector)
    if(!el){
        throw new Error(`Element ${selector} not found`)
    }

    if(e.target.tagName == "BUTTON"){
        e.target.disabled = true
    }

    el.disabled = false

    el.querySelector("input,textarea,select")
        ?.focus()
}

// INIT

let now = new Date();
form.elements["upload-date"].value = `${now.getFullYear()}-${(now.getMonth()+1).toString().padStart(2, "0")}-${(now.getDate()).toString().padStart(2, "0")}`
form.hidden = false;